<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="经常问到的问题 － Apache 2.2 中文手册 [金步国作品集]">
<title>经常问到的问题 － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body id="manual-page"><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">常见问题</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2007年4月4日</div>
<div id="page-content"><div id="preamble"><h1>经常问到的问题</h1>


    <p>这个FAQ的最新版本总是可以从Apache主站点得到，位于&lt;<a href="https://httpd.apache.org/docs/2.2/faq/">https://httpd.apache.org/docs/2.2/faq/</a>&gt;</p>

    <p>如果你的问题在这里没有找到答案，你也可以看看<a href="https://httpd.apache.org/docs/misc/FAQ.html">Apache 1.3
    FAQ</a> ，看你的问题是否在那里有了答案。</p>
</div>
	<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a id="topics" name="topics">主题</a></h2>
<dl><dt><a href="#background">背景</a></dt><dd>关于 Apache HTTP Server 的背景知识。</dd>
<dt><a href="#support">支持</a></dt><dd>我遇到问题该怎么办？</dd>
<dt><a href="#error">错误信息</a></dt><dd>这些错误信息是什么意思？</dd>
</dl></div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="background" id="background">背景</a></h2>

    <ul>
    <li><a href="#background.what-is-apache">什么是Apache ？</a></li>
    <li><a href="#background.what-is-httpd">什么是 Apache HTTP Server ？</a></li>
    <li><a href="#background.tested">Apache是如果进行充分测试的？</a></li>
    <li><a href="#background.logo">我可以在我的产品或网站中使用Apache的logo吗？</a></li>
    </ul>

    <h3><a name="background.what-is-apache" id="background.what-is-apache">什么是Apache ？</a></h3>


      <p>Apache软件基金会(ASF)是一个非营利性组织，它为Apache社区的开源软件项目提供支持。欲知详情，请查看<a href="https://www.apache.org/foundation/faq.html">Apache Software Foundation FAQ</a>页面。</p>

      <p>Apache HTTP Server(也被称为Apache httpd)是Apache软件基金会的一个创建健壮的、工业级的、功能强大的、开放源代码的HTTP(Web)服务器的项目。欲知详情，请查看<a href="https://httpd.apache.org/ABOUT_APACHE.html">About Apache</a>页面。</p>



	<h3><a name="background.what-is-httpd" id="background.what-is-httpd">什么是 Apache HTTP Server ？</a></h3>

      <ul>
        <li>一个强大的、灵活的、兼容HTTP/1.1规范的web服务器</li>
        <li>实现了最新的协议，包括HTTP/1.1(RFC2616)</li>
        <li>具有高度的可配置性和使用第三方模块的可扩展性</li>
        <li>可以通过使用Apache模块API编写自己的模块进行定制</li>
        <li>在<a href="https://www.apache.org/licenses/LICENSE-2.0">非限制性许可证</a>下提供所有的源代码</li>
        <li>可以运行在 Windows 2003/XP/2000/NT/9x 、Netware 5.x 及以上版本、OS/2 、大多数Unix版本以及其它操作系统上</li>
        <li>被非常活跃的进行开发</li>
        <li>鼓励用户反馈新想法、bug报告、补丁程序</li>
      </ul>


	<h3><a name="background.tested" id="background.tested">Apache是如果进行充分测试的？</a></h3>

      <p>Apache正在数以百万的网络服务器上运行。它同时经过开发者和用户的充分测试。Apache HTTP Server 项目按照非常严格的标准发布服务器的新版本，并且有70%的WWW服务器在24小时不间断地运行着我们的服务器。一旦有bug被发现，我们将以最快的速度发布补丁程序和新版本。</p>


	<h3><a name="background.logo" id="background.logo">我可以在我的产品或网站中使用Apache的logo吗？</a></h3>

      <p><em>不可以</em>使用、复制、修改任何来自Apache软件基金会的原始图形。除非满足以下条件：</p>
      <ul>
        <li>你可以在一个使用Apache作为web服务器的网站上使用<a href="https://httpd.apache.org/docs/apache_pb.gif">'Powered by Apache'图标</a>。</li>
        <li><em>当且仅当</em>这种使用可以促进Apache的推广时，你才可以在产品描述中使用上述<a href="https://httpd.apache.org/docs/apache_pb.gif">'Powered by Apache'图标</a>或<a href="https://www.apache.org/images/asf_logo.gif">Apache软件基金会logo</a> 。严格禁止将Apache的名称或图形用于产品的签名或者服务。</li>
      </ul>

 </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="support" id="support">支持</a></h2>
    <ul>
    <li><a href="#support.what2do">"我为什么不能...？为什么...不工作？"在有问题的情况下该怎么办？</a></li>

    <li><a href="#support.support">我要找谁寻求帮助？</a></li>
    </ul>

    <h3><a name="support.what2do" id="support.what2do">"我为什么不能...？为什么...不工作？"在有问题的情况下该怎么办？</a></h3>


      <p>如果你使用Apache服务器软件遇到了问题，采取以下几步：</p>

      <dl>
      <dt>检查错误日志！</dt>
      <dd>Apache服务器在遇到问题时会尽力做到对你有所帮助。在许多情况下，它会通过在错误日志中写入一条或多条消息来提供一些细节。有时这已经足够让你自己诊断和解决问题了(比如文件权限或类似的问题)。错误日志的默认位置在<code>/usr/local/apache2/logs/error_log</code> ，但是最后还是看看配置文件中的<code class="directive"><a href="../mod/core.html#errorlog">ErrorLog</a></code>指令以确认错误日志在你服务器上的确切位置。</dd>

      <dt>再一次检查错误日志！</dt>
      <dd>几乎所有问题都可以通过阅读错误日志来解决。</dd>

      <dt>察看<a href="https://httpd.apache.org/docs/2.2/faq/">FAQ</a>!</dt>
      <dd>最新版本的Apache常见问题列表总是可以从Apache主站点得到。</dd>

      <dt>察看Apache bug数据库</dt>
      <dd>大多数报告给Apache项目组的问题都记录在<a href="https://httpd.apache.org/bug_report.html">bug数据库</a>中。在你添加一个新bug之前，请<strong>务必</strong>检查已有的报告(打开的<strong>和</strong>关闭的)。如果你发现你的问题已经被报告了，请<em>不要</em>添加一个"我也是"那样的报告。如果原始报告还没有关闭，我们建议你经常周期性地来看看它。你也可以考虑与最初的提交者接触，因为有可能会在邮件交流中发现没有记录在数据库中的问题。</dd>

      <dt><a id="support.what2do.user-support" name="support.what2do.user-support">在某个用户论坛中提问</a></dt>
      <dd>
      	<p>Apache拥有一个活跃的、愿意共享知识的用户社区。参与这个社区通常是获得解答的最快最好的办法。</p>

      <p><a href="https://httpd.apache.org/userslist.html">用户邮件列表</a></p>

      <p><a href="http://freenode.net">Freenode IRC</a>上的<a href="irc://irc.freenode.net/#apache">#apache</a>频道也是关于用户支持的。</p>
      </dd>

      <dt>提交问题报告到bug数据库</dt>
      <dd><p>如果做了以上几个合适的步骤而没有得到解答，那么请<em>务必</em>让httpd的开发者了解这个问题，到这里<a href="https://httpd.apache.org/bug_report.html">提交bug报告</a>。</p>

      <p>如果你的问题涉及到服务器崩溃并产生了内核dump，请在报告中<a href="https://httpd.apache.org/dev/debugging.html">包含一个backtrace</a>(如果可能)。</p>
      </dd>
      </dl>


    <h3><a name="support.support" id="support.support">我要找谁寻求帮助？</a></h3>
      <p>因为有数百万用户和区区不到60名志愿开发者，我们无法为Apache提供个体支持。对于免费的支持，我们建议用户参与一个<a href="#support.what2do.user-support">用户论坛</a>。</p>

      <p>Apache的专业商业支持可以从<a href="https://www.apache.org/info/support.cgi">许多公司</a>得到。</p>

</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="error" id="error">错误信息</a></h2>
    <ul>
    <li><a href="#error.sendfile">Invalid argument: core_output_filter: writing data to the network</a></li>
    <li><a href="#error.acceptex">AcceptEx failed</a></li>
    <li><a href="#error.scriptheaders">Premature end of script headers</a></li>
    <li><a href="#error.permissiondenied">Permission denied</a></li>
    </ul>

    <h3><a name="error.sendfile" id="error.sendfile">Invalid argument: core_output_filter: writing data to the network</a></h3>

    <p>Apache在可能的平台上使用系统调用<code>sendfile</code>来加速响应的发送(译者注：Linux2.4/2.6内核都支持)。不幸的是，在某些系统上，Apache会在编译时检测<code>sendfile</code>的存在，即使它不能正常工作。这经常发生在使用网络或其他非标准文件系统时。</p>

    <p>这个问题的表现症状包括上述信息出现在错误日志里及对于非零长度文件请求发送零长度的响应。一般这个问题只发生在静态文件上，因为动态文件通常用不到<code>sendfile</code> 。</p>

    <p>要修正这个问题，可用<code class="directive"><a href="../mod/core.html#enablesendfile">EnableSendfile</a></code>指令关闭服务器所有部分对<code>sendfile</code>的使用即可。同时参看<code class="directive"><a href="../mod/core.html#enablemmap">EnableMMAP</a></code>指令，对相似的问题有帮助。</p>



    <h3><a name="error.acceptex" id="error.acceptex">AcceptEx Failed</a></h3>

    <p>如果你在win32系统上得到一个与<code>AcceptEx</code>系统调用相关的错误信息，参见<code class="directive"><a href="../mod/mpm_winnt.html#win32disableacceptex">Win32DisableAcceptEx</a></code>指令。</p>



    <h3><a name="error.scriptheaders" id="error.scriptheaders">Premature end of script headers</a></h3>

    <p>大多数导致这个错误的CGI脚本问题将会向浏览器发送一个"<code>Internal Server Error</code>"错误信息。要解决这种问题参见：<a href="../howto/cgi.html#troubleshoot">CGI指南</a>。</p>


    <h3><a name="error.permissiondenied" id="error.permissiondenied">Permission denied</a></h3>

    <p><code>error_log</code>中的"<code>Permission denied</code>"错误伴随一个发送到客户端的"<code>Forbidden</code>"信息通常表明违反了文件系统的权限，而不是Apache HTTP的配置文件出了错误。检查并确认用于运行子进程的<code class="directive"><a href="../mod/mpm_common.html#user">User</a></code>和<code class="directive"><a href="../mod/mpm_common.html#group">Group</a></code>有访问导致问题的文件的足够权限。同时检查一下导致问题的文件所在的目录及其所有父目录是否具有执行(搜索)权限(也就是 <code>chmod +x</code>)。</p>

    <p>最近发行的 Fedora Core 和其它Linux发行版使用了SELinux进行额外的访问控制，违反这些限制也会导致"<code>Permission denied</code>"消息。参见<a href="http://fedora.redhat.com/docs/selinux-faq-fc3/">Fedora SELinux FAQ</a>和<a href="http://fedora.redhat.com/docs/selinux-apache-fc3/">Apache SELinux Policy Document</a>以获得更多信息。</p>



</div></div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
